#!/bin/sh
INSTALL_DIR=~/agileway/buildwise-agent-2.0.3
AGENT_RESULTS_DIR=~/.buildwise/agent-test-results
SYMBOLIC_LINK=~/agileway/buildwise-agent 

# echo $SYMBOLIC_LINK

if [ -d "$AGENT_RESULTS_DIR" ]; then
  echo "agent results ${AGENT_RESULTS_DIR} exists"
else
  echo "[INFO] Create ${AGENT_RESULTS_DIR}"
  mkdir -p $AGENT_RESULTS_DIR
  touch $AGENT_RESULTS_DIR/.keep
fi

if [ -d "$INSTALL_DIR" ]; then
  rm -rf $INSTALL_DIR
fi
mkdir -p $INSTALL_DIR

cp -r ./* $INSTALL_DIR

if [ -L "$SYMBOLIC_LINK"  ]; then
  rm $SYMBOLIC_LINK
fi
ln -s $INSTALL_DIR $SYMBOLIC_LINK

rm ${INSTALL_DIR}/install.sh

sed -e "s|%AGENT_HOME%|$SYMBOLIC_LINK|g" ${INSTALL_DIR}/BuildWiseAgent.desktop > ~/Desktop/BuildWiseAgent.desktop
chmod +x ~/Desktop/BuildWiseAgent.desktop

# cp ${INSTALL_DIR}/BuildWiseAgent.desktop ~/Desktop/

echo "[OK] BuildWise Agent installed under ${INSTALL_DIR}"
